VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmRegEnum 
   Caption         =   "Enumerate Registry "
   ClientHeight    =   5940
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   7740
   Icon            =   "RegEnum.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5940
   ScaleWidth      =   7740
   Begin VB.TextBox txtLimitLength 
      Height          =   285
      Left            =   1590
      TabIndex        =   8
      Text            =   "64000"
      Top             =   1560
      Width           =   675
   End
   Begin VB.CheckBox Check1 
      Alignment       =   1  'Right Justify
      Caption         =   "Display subkeys only"
      Height          =   285
      Left            =   2700
      TabIndex        =   6
      Top             =   1560
      Width           =   1965
   End
   Begin RichTextLib.RichTextBox Text1 
      Height          =   3285
      Left            =   150
      TabIndex        =   5
      Top             =   2010
      Width           =   7425
      _ExtentX        =   13097
      _ExtentY        =   5794
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"RegEnum.frx":030A
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   420
      Width           =   4065
   End
   Begin VB.TextBox txtSubKey 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   1110
      Width           =   5775
   End
   Begin VB.CommandButton cmdEnumerate 
      Caption         =   "Enumerate"
      Default         =   -1  'True
      Height          =   375
      Left            =   6360
      TabIndex        =   1
      Top             =   1500
      Width           =   1245
   End
   Begin VB.Label lblLimtLength 
      Caption         =   "Limit (chars)"
      Height          =   255
      Left            =   600
      TabIndex        =   7
      Top             =   1590
      Width           =   885
   End
   Begin VB.Label lblMainKey 
      Caption         =   "Main key"
      Height          =   255
      Left            =   150
      TabIndex        =   4
      Top             =   90
      Width           =   1905
   End
   Begin VB.Label lblSubKey 
      Caption         =   "Subkey (case sensitive):"
      Height          =   255
      Left            =   150
      TabIndex        =   2
      Top             =   840
      Width           =   1905
   End
End
Attribute VB_Name = "frmRegEnum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' RegEnum.frm
'
' By Herman Liu
'
' A demo on enumerating all subkeys of a subkey, and their subkeys, entries and values.
'
Option Explicit

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" _
    (ByVal hkey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, _
    ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" _
    (ByVal hkey As Long, ByVal dwIndex As Long, ByVal lpName As String, _
    lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, _
    lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" _
    (ByVal mKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, _
    lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hkey As Long) As Long
Private Declare Function RegEnumValueType Lib "advapi32.dll" Alias "RegEnumValueA" _
    (ByVal hkey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
    lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, _
    ByVal null1 As Long, ByVal null2 As Long) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" _
    (ByVal hkey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
    lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Byte, _
    lpcbData As Long) As Long
Private Declare Function RegEnumValueString Lib "advapi32.dll" Alias "RegEnumValueA" _
    (ByVal hkey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
    lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As String, _
    lpcbData As Long) As Long

Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const HKEY_USERS = &H80000003
Private Const HKEY_PERFORMANCE_DATA = &H80000004
Private Const HKEY_CURRENT_CONFIG = &H80000005
Private Const HKEY_DYN_DATA = &H80000006
Private Const ERR_MORE_DATA = 234
' Reg key security attribute
Private Const KEY_QUERY_VALUE = &H1&
Private Const KEY_SET_VALUE = &H2&
Private Const KEY_ALL_ACCESS = &H3F
Private Const KEY_CREATE_SUBKEY = &H4&
Private Const KEY_ENUMERATE_SUBKEY = &H8&
Private Const KEY_NOTIFY = &H10&
Private Const KEY_CREATE_LINK = &H20
Private Const READ_CONTROL = &H20000
Private Const WRITE_OWNER = &H80000
Private Const STANDARD_RIGHTS_REQUIRED = &HF0000
Private Const STANDARD_RIGHTS_READ = READ_CONTROL
Private Const STANDARD_RIGHTS_WRITE = READ_CONTROL
Private Const STANDARD_RIGHTS_EXECUTE = READ_CONTROL
Private Const KEY_READ = STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or _
      KEY_ENUMERATE_SUBKEY Or KEY_NOTIFY
Private Const KEY_WRITE = STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUBKEY

Private Const REG_NONE = 0
Private Const REG_SZ = 1                 ' Unicode null terminated string
Private Const REG_EXPAND_SZ = 2
Private Const REG_BINARY = 3             ' Binary
Private Const REG_DWORD = 4              ' 32-bit number
Private Const REG_DWORD_LITTLE_ENDIAN = 4
Private Const REG_DWORD_BIG_ENDIAN = 5
Private Const REG_LINK = 6
Private Const REG_MULTI_SZ = 7
Private Const REG_RESOURCE_LIST = 8
Private Const REG_FULL_RESOURCE_DESCRIPTOR = 9
Private Const REG_RESOURCE_REQUIREMENTS_LIST = 10

Dim mMainKey As Long
Dim mIndent As Integer
Dim mStopFlag As Boolean
Dim mAccumText As String                 ' To avoid blinks (if changing Text1 every time)
Dim mResult As Long




Private Sub Form_Load()
    Combo1.Clear
    Combo1.AddItem "HKEY_CLASSES_ROOT"
    Combo1.AddItem "HKEY_CURRENT_USER"
    Combo1.AddItem "HKEY_LOCAL_MACHINE"
    Combo1.AddItem "HKEY_USERS"
    Combo1.AddItem "HKEY_PERFORMANCE_DATA"
    Combo1.AddItem "HKEY_CURRENT_CONFIG"
    Combo1.AddItem "HKEY_DYN_DATA"
      
    Combo1.ListIndex = 2
    mMainKey = GetMainKey(Combo1.List(Combo1.ListIndex))
    mStopFlag = False
    Text1.Text = ""
    txtSubKey.Text = "SOFTWARE\Microsoft\Windows\CurrentVersion\SETUP"
End Sub



Private Sub Combo1_Click()
     Dim mName As String
     mName = Combo1.List(Combo1.ListIndex)
     mMainKey = GetMainKey(mName)
End Sub


Private Function GetMainKey(ByVal inName As String) As Long
    GetMainKey = 0
    If inName = "HKEY_CLASSES_ROOT" Then
        GetMainKey = HKEY_CLASSES_ROOT
    ElseIf inName = "HKEY_CURRENT_USER" Then
        GetMainKey = HKEY_CURRENT_USER
    ElseIf inName = "HKEY_LOCAL_MACHINE" Then
        GetMainKey = HKEY_LOCAL_MACHINE
    ElseIf inName = "HKEY_USERS" Then
        GetMainKey = HKEY_USERS
    ElseIf inName = "HKEY_PERFORMANCE_DATA" Then
        GetMainKey = HKEY_PERFORMANCE_DATA
    ElseIf inName = "HKEY_CURRENT_CONFIG" Then
        GetMainKey = HKEY_CURRENT_CONFIG
    ElseIf inName = "HKEY_DYN_DATA" Then
        GetMainKey = HKEY_CURRENT_CONFIG
    End If
End Function




Private Sub cmdEnumerate_Click()
    If cmdEnumerate.Caption = "Stop" Then
           ' Enable user to escape with colSubKeys and entries are too many
           ' (This is quite possible if subkey set has many colSubKeys)
         mStopFlag = True
         cmdEnumerate.Caption = "Enumerate"
           ' Prevent further running (must exit program)
         cmdEnumerate.Enabled = False
    Else
         mStopFlag = False
         cmdEnumerate.Caption = "Stop"
         mAccumText = ""
         Text1.Text = ""
         mIndent = 0
         Screen.MousePointer = vbHourglass
         DoEnumSubKeys mMainKey, Trim(txtSubKey.Text)
         Text1.Text = mAccumText
         cmdEnumerate.Caption = "Enumerate"
    End If
    Screen.MousePointer = vbDefault
End Sub




Private Sub DoEnumSubKeys(ByVal inMainKey As Long, ByVal inSubKey As String)
    Dim mKey As Long
    Dim colSubKeys As Collection
    Dim mBuffer As String * 256
    Dim mBufSize As Long
    Dim mClassBuffer As String * 256
    Dim mClassBufSize As Long
    Dim typLastWriteTime As FILETIME
    
    Dim mSubKeyName As String
    Dim mSubKeyValue As String
    Dim mValType As Long
    Dim mIndex As Integer
    Dim i As Integer

    Set colSubKeys = New Collection
    If RegOpenKeyEx(inMainKey, inSubKey, 0&, KEY_ALL_ACCESS, mKey) <> 0 Then
        MsgBox "Unable to open a subkey"
        Exit Sub
    End If

    ListEntryValues inMainKey, inSubKey
    
       ' The above list the current subkey and its own entries and values

       '===================================================================
       ' Enumerate the Subkey's colSubKeys
    mIndex = 0
    Do
         ' lpClassBuffer is a pointer to a buffer that receives the null-terminated
         ' class string of the enumerated subkey. No classes are currently defined;
         ' hence this parameter can be NULL.
         ' lpClassBufSize is a pointer to a variable that specifies the size of
         ' lpClassBuffer, including the terminating null character. When the function
         ' returns, it contains the number of characters stored in the buffer.
         ' The count returned does not include the terminating null character.
        
        mClassBuffer = ""
        mClassBufSize = 0
        mBufSize = 256
        mSubKeyName = Space$(mBufSize)
        
        mResult = RegEnumKeyEx(mKey, mIndex, mSubKeyName, mBufSize, 0, mClassBuffer, _
                mClassBufSize, typLastWriteTime)
        If mResult <> ERR_MORE_DATA And mResult <> 0 Then
             'MsgBox APIErrorDescription(mResult)
             Exit Do
        End If
        
        mSubKeyName = Left$(mSubKeyName, InStr(mSubKeyName, Chr$(0)) - 1)
        colSubKeys.Add mSubKeyName
        mIndex = mIndex + 1
    Loop
    
    RegCloseKey mKey
    
    If mIndex > 0 Then
        mIndent = mIndent + 3
    Else
        mIndent = 3
    End If
       
       ' Recursively get information on the keys.
    For i = 1 To colSubKeys.Count
        DoEvents
          ' Registry is a huge database; in case user input is a big subkey,
          ' we don't want to wait for too long.  Hence set a limit here.
        If Len(mAccumText) > Val(txtLimitLength.Text) Then
            mAccumText = mAccumText & "......(more) ......." & vbCrLf
            mStopFlag = True     ' To spin off the loop of "For mIndex = 1 To colSubKeys.Count"
            Exit For
        End If
        If mStopFlag Then
             Exit For
        End If
        DoEnumSubKeys inMainKey, inSubKey & "\" & colSubKeys(i)
    Next i
End Sub





Private Sub ListEntryValues(ByVal inMainKey As Long, ByVal inSubKey As String)
    Dim mKey As Long
    Dim mIndex As Long
    Dim mReturnEntry As String
    Dim mEntry As String
    Dim mEntryLength As Long
    Dim mDataType As Long
    Dim arrDataByte(1 To 1024) As Byte
    Dim mDataByteLength As Long
    Dim mDataByteValue As String
    Dim i As Integer
    Dim j
    Dim y
    Dim tmp As String, mChr As String
    Dim mAlignPos, mAlignPos0, mAlignPos1
    
    mResult = RegOpenKeyEx(inMainKey, inSubKey, 0&, KEY_ALL_ACCESS, mKey)
    If mResult <> 0 Then
        MsgBox "Error RegOpenKeyEx for " & inSubKey
        Exit Sub
    End If
    
     '-----------------------------
    tmp = ""
    For i = Len(inSubKey) To 1 Step -1
        mChr = Mid(inSubKey, i, 1)
        If mChr = "\" Then
            Exit For
        End If
        tmp = mChr & tmp
    Next i
    
      ' Display subkey (without its parent) and its own entries (& values),
      ' at a position of mIndent
    mAccumText = mAccumText & Space(mIndent) & tmp
    
    mAlignPos0 = 5
    mAlignPos1 = mAlignPos0 + mIndent + Len(tmp)
    
    
    If Check1.Value = vbChecked Then                ' Display subkey(s) only
             ' Next line for another subkey
          mAccumText = mAccumText & vbCrLf
          Exit Sub
    End If
    
    mIndex = 0
    Do
        If mIndex = 0 Then
             mAlignPos = mAlignPos0
        Else
             mAlignPos = mAlignPos1
        End If
    
        mEntryLength = 1024
        mDataByteLength = 1024
        mEntry = Space$(mEntryLength)
        mResult = RegEnumValue(mKey, mIndex, mEntry, mEntryLength, 0, _
             mDataType, arrDataByte(1), mDataByteLength)
        If mResult <> 0 Then                  ' No more
             Exit Do
        End If

        mEntry = Left$(mEntry, mEntryLength)
        
          ' Note if value is "(No value set)" then the following
          ' will not be display, i.e. as if no entry exists.
        If mEntry = "" And mDataByteLength > 0 Then
             mEntry = "[Default]"
        End If
        
        mDataByteValue = ""
        Select Case mDataType
            Case REG_SZ
                For i = 1 To mDataByteLength - 1
                    mDataByteValue = mDataByteValue & Chr$(arrDataByte(i))
                Next i
                mAccumText = mAccumText & Space(mAlignPos) & mEntry & " = """ & _
                     mDataByteValue & """" & vbCrLf
            Case REG_DWORD
                   ' For display in original format as in registry
                tmp = ""
                For i = 4 To 1 Step -1
                     mChr = Hex(Asc(Chr(arrDataByte(i))))
                     If Len(mChr) = 1 Then
                          mChr = "0" + mChr
                     End If
                     tmp = tmp & mChr
                Next
                   ' For display of actual value in decimal as in registry
                y = 0
                For i = 1 To Len(tmp) Step 2
                     mChr = Mid(tmp, i, 2)
                     mChr = ConvNum(mChr, 16, 10)
                     j = Val(mChr)
                     Select Case i
                         Case 1
                             j = j * &H1000000         ' 16777216
                         Case 2
                             j = j * &H10000           ' 65536
                         Case 3
                             j = j * &H100             ' 256
                     End Select
                     y = y + j
                Next
                mDataByteValue = CStr(y)
                mAccumText = mAccumText & Space(mAlignPos) & mEntry & " = (DWORD) """ & tmp & _
                    " (" & mDataByteValue & ")" & """" & vbCrLf
            Case REG_BINARY
                For i = 1 To mDataByteLength
                     mChr = Hex$(Asc(Chr(arrDataByte(i))))
                     If Len(mChr) = 1 Then
                          mChr = "0" & mChr
                     End If
                     mDataByteValue = mDataByteValue & mChr & " "
                Next
                mAccumText = mAccumText & Space(mAlignPos) & mEntry & " = (BINARY) """ & _
                     Trim(mDataByteValue) & """" & vbCrLf
            Case Else
                mAccumText = mAccumText & Space(mAlignPos) & mEntry & " = (Value not string, numeric or binary type)" & vbCrLf
        End Select
        mIndex = mIndex + 1
    Loop
    
      ' Next line for another subkey
    mAccumText = mAccumText & vbCrLf
End Sub



Private Function ConvNum(inNum As String, inFrom As Integer, inTo As Integer) As String
    Dim mChr As String
    Dim i As Integer, j As Integer, k As Integer
    Dim mTotal As Double, mMod As Double, tmp As Double
    ConvNum = ""
    If inNum = "" Then
         Exit Function
    ElseIf inFrom < 2 Or inFrom > 36 Then
         Exit Function
    ElseIf inTo < 1 Or inTo > 36 Then
         Exit Function
    End If
       ' Convert to decimal
    inNum = UCase$(inNum)
    k = Len(inNum)
    For i = 1 To Len(inNum)
         k = k - 1
         mChr = Mid$(inNum, i, 1)
         j = 0
         If Asc(mChr) > 64 And Asc(mChr) < 91 Then
             j = Asc(mChr) - 55
         End If
         If j = 0 Then
              If Asc(mChr) < 48 Or Asc(mChr) > 57 Then
                  Exit Function
              End If
              j = Val(mChr)
         End If

         If j < 0 Or j > inFrom - 1 Then
              Exit Function
         End If
         mTotal = mTotal + j * (inFrom ^ k)
    Next i
       ' In target base
    Do While mTotal > 0
         tmp = CDbl(inTo)
         mMod = mTotal - (Int(mTotal / tmp) * tmp)
         mTotal = (mTotal - mMod) / inTo
         If mMod >= 10 Then
              mChr = Chr$(mMod + 55)
         Else
              mChr = Right$(Str$(mMod), Len(Str$(mMod)) - 1)
         End If
         ConvNum = mChr & ConvNum
    Loop
    If ConvNum = "" Then
         ConvNum = "0"
    End If
End Function



' Here we resize Text1 only
Private Sub Form_Resize()
    Dim h As Single, w As Single
      ' Avoid runtime error
    h = Me.ScaleHeight - Text1.Top
    If h < 150 Then
         h = 150
    End If
    Text1.Move 0, Text1.Top, Me.ScaleWidth, h
End Sub



Private Sub txtLimitLength_keypress(KeyAscii As Integer)
    KeyAscii = FilterNumericKey(KeyAscii)
End Sub


Private Sub txtSubKey_Change()
    cmdEnumerate.Enabled = Trim(txtSubKey.Text <> "")
End Sub



Private Sub txtLimitLength_change()
    If Trim(txtLimitLength.Text) = "" Then
         txtLimitLength.Text = 64000
    End If
End Sub



Private Sub Form_Unload(Cancel As Integer)
    End
End Sub



Function FilterNumericKey(inkey) As Integer
    If inkey < Asc("0") Or inkey > Asc("9") Then
        If inkey <> 8 Then                      'Allow Backspace
              inkey = 0            ' Cancel the typed in character
        End If
    End If
    FilterNumericKey = inkey
End Function


